/******************************************************************************
 *            g_fenetre_principale.c                                          *
 *                                                                            *
 *  Copyright  2006  gerald.dumas                                             *
 *  linechec@laposte.net                                                      *
 ******************************************************************************
 *                                                                            *
 *  This program is free software; you can redistribute it and/or modify      *
 *  it under the terms of the GNU General Public License as published by      *
 *  the Free Software Foundation; either version 2 of the License, or         *
 *  any later version.                                                        *
 *                                                                            *
 *  This program is distributed in the hope that it will be useful,           *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU General Public License for more details.                              *
 *                                                                            *
 *  You should have received a copy of the GNU General Public License         *
 *  along with this program; if not, write to the Free Software               *
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.*
 ******************************************************************************/
#include "g_fenetre_principale.h"

void g_calcul_taille_echiquier (GtkWidget * widget,
			   GtkAllocation * allocation, gpointer user_data)
{
  static gint actual_width=0;
  static gint actual_height=0;

	if ((allocation->width !=actual_width || allocation->height!=actual_height)
		&& (allocation->width>200))
	{
		gchar *tmp, *tmp2;
		gchar *chemin;
		register gint x,y;
		gint taille_echiquier;

		actual_width=allocation->width;
		actual_height=allocation->height;

		// Changement de la taille des pièces et des cases
		taille_echiquier=(gint)((actual_height/actual_width)*actual_width);
		if (actual_height<=actual_width)
			taille_echiquier=actual_height;
		else
			taille_echiquier=actual_width;
		TAILLE_PIECE= (gint)((taille_echiquier-40)/8);
		// Libération mémoire des anciennes images
		for (x=0; x<7; x++)
		{
			for (y=0; y<2; y++)
			{
				g_object_unref(buf_images[x][y]);
			}
		}
		// Chargement des nouvelles images.
		tmp=g_key_file_get_string(key_file_config, "DIRECTORY", "install", NULL);
		if (strcmp(tmp, "/usr/bin")==0)
		{
			g_free(tmp);
			// DEBUG by xcfaudio: changing the order of directories
			// tmp=g_strdup("/usr/share/linechec/pixmaps");
			tmp=g_strdup("/usr/share/pixmaps/linechec");
		}
		else
		{
			g_free(tmp);
			tmp=g_strdup_printf("%s/pixmaps",g_key_file_get_string(key_file_config, "DIRECTORY", "install", NULL));
		}

		tmp2=g_key_file_get_string(key_file_config, "DIRECTORY", "chess_pixmaps", NULL);
		for (x=0; x<7; x++)
		{
			for (y=0; y<2; y++)
			{
				// Chargement de l'image dans un GtkImage;
				chemin=g_strdup_printf("%s/echiquier/%s/%s",tmp,tmp2, table_nom_images[x][y]);
				buf_images[x][y]=gdk_pixbuf_new_from_file_at_scale(chemin, TAILLE_PIECE, TAILLE_PIECE, FALSE, NULL);
				g_free(chemin);
			}
		}
		g_free(tmp);
		g_free(tmp2);
	}
}

GtkWidget * nouvelle_fenetre_principale (GtkWidget * fenetre_principale)
{
  GtkWidget *boite_principale;	// Contient tous les autres widgets.
	GtkWidget *paned;
	GtkWidget *cadre_partie;
	GtkWidget *Ascenseur;
	GtkListStore *coup_affiche;
	GtkWidget *table_pieces_prises;
	GtkWidget *cadre_pieces_prises;
	GtkWidget *barre_outils;
	GtkWidget *table_navigation;
	GtkWidget *table_paned_droit; // Contient notebook, boite.
	GtkWidget *scrolledwindow_paned_droit; // Contient table_paned_droit
  gchar *label;		//Variable temporaire pour la construction de texte.
  GtkWidget * G_label;
//	GtkWidget *image_reseau;  // Contient le STOCK_ID_NETWORK
  GtkWidget * barre_menu;
	GtkWidget * separateur_horizontal;	// décors
	GdkPixbuf *icone_appli;
	icone_appli=(GdkPixbuf*)
								(gtk_data_list_get_by_name(widget_list, "icone_appli"));
	GtkWidget *Zone_dessin;
	GtkWidget *bouton_debut;
	GtkWidget *bouton_recul;
	GtkWidget *bouton_avance;
	GtkWidget *bouton_dernier_coup;
	GtkWidget *view;
	GtkWidget *barre_etat;
	GtkWidget *connexion;

	// Contient les coups affichés, les boutons de naviguation et le tableau des
	// pièces prises
  PangoFontDescription * font_desc;
	GtkWidget * boite;

	// Pour la création et l'affichage des titres de cadre_partie.
  GtkCellRenderer * renderer;
  GtkTreeViewColumn * column;

//	GtkWidget *table_reseau;
  GtkWidget * notebook; GtkWidget * ascenseur_etat;	// Ascenseur de la fenêtre
																										// d'état de la connexion.
	GtkTooltips * connexion_tips;	// tooltip pour le widget connexion
	GtkWidget * event_tips;	// Nécessaire pour l'affichage du tooltips

	// création de la fenêtre principale
	fenetre_principale = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_position (GTK_WINDOW (fenetre_principale), GTK_WIN_POS_CENTER);
	gtk_window_set_default_size(GTK_WINDOW(fenetre_principale), 1000, 600);
	label = g_strdup_printf ("%s %s",
						g_key_file_get_string (key_file_config, "COMMON", "name", NULL),
			 			g_key_file_get_string (key_file_config, "COMMON", "version", NULL));
	gtk_window_set_title (GTK_WINDOW (fenetre_principale), label);
	g_free (label); gtk_widget_realize (fenetre_principale);
	// affectation d'une icône à la fenêtre principale
	gtk_window_set_icon (GTK_WINDOW (fenetre_principale), icone_appli);
	// Déclaration de la boîte qui contient tous les autres widgets
	boite_principale = gtk_vbox_new (FALSE, 0);
	gtk_container_add (GTK_CONTAINER (fenetre_principale), boite_principale);
	// Insertion d'une barre de menu
	barre_menu = creation_menu (fenetre_principale, boite_principale);
	gtk_box_pack_start (GTK_BOX (boite_principale), barre_menu, FALSE, FALSE,
		0);
	// création de la barre d'outils
	barre_outils = creation_barreoutils (fenetre_principale);
	widget_list=gtk_data_list_add_by_name(widget_list, barre_outils,
																																"barre outils");
	gtk_toolbar_set_orientation (GTK_TOOLBAR (barre_outils),
			 GTK_ORIENTATION_HORIZONTAL);
	gtk_toolbar_set_style (GTK_TOOLBAR (barre_outils), GTK_TOOLBAR_ICONS);
	gtk_box_pack_start (GTK_BOX (boite_principale), barre_outils, FALSE,
		FALSE, 0);
	// Insertion d'une ligne séparatrice horizontale entre la barre d'outils et
	// l'échiquier.
	separateur_horizontal = gtk_hseparator_new ();
	gtk_box_pack_start (GTK_BOX (boite_principale), separateur_horizontal,
		FALSE, FALSE, 0);

	// Création d'un paned horizontale
	paned=gtk_hpaned_new();
	gtk_box_pack_start (GTK_BOX (boite_principale), paned, TRUE, TRUE, 0);
	creation_echiquier_graphic (fenetre_principale, paned);
	Zone_dessin=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "Zone dessin"));
	g_signal_connect (G_OBJECT (Zone_dessin), "size-allocate",
				(GCallback) g_calcul_taille_echiquier, paned);

	// Création d'une table pour contenir les coups joués, la navigation,
	// les pièces prises ainsi que le notebook
	table_paned_droit=gtk_table_new(1, 1, FALSE);
	// Création d'un scrolledwindow pour contenir la table_paned_droit;
	scrolledwindow_paned_droit=gtk_scrolled_window_new(NULL, NULL);
	gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW
	(scrolledwindow_paned_droit), table_paned_droit);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW
			(scrolledwindow_paned_droit), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

	// Création de la boite qui contient les coups affichés, les boutons de
	//naviguation et les pièces prises.
	boite = gtk_vbox_new (FALSE, 0);
	gtk_paned_add2 (GTK_PANED(paned), scrolledwindow_paned_droit);
	gtk_table_attach(GTK_TABLE(table_paned_droit), boite,0,1,0,1,GTK_SHRINK,
																										GTK_FILL|GTK_EXPAND, 0, 0);

	// Création du cadre d'affichage de la partie en cours
	coup_affiche=gtk_list_store_new (3, G_TYPE_INT, G_TYPE_STRING, G_TYPE_STRING);
	widget_list=gtk_data_list_add_by_name(widget_list, coup_affiche,
																																"coup affiche");
	// Création du widget d'affichage
	cadre_partie = gtk_tree_view_new_with_model (GTK_TREE_MODEL (coup_affiche));
	widget_list=gtk_data_list_add_by_name(widget_list, cadre_partie,
																																"cadre_partie");
	gtk_widget_set_size_request (cadre_partie, 210, 350);
	renderer = gtk_cell_renderer_text_new ();
	column = gtk_tree_view_column_new_with_attributes ("Coups", renderer, "text",
																											0, NULL);
	gtk_tree_view_append_column (GTK_TREE_VIEW (cadre_partie), column);
	column =
	gtk_tree_view_column_new_with_attributes ("Blancs", renderer, "text", 1,
							NULL);
	gtk_tree_view_append_column (GTK_TREE_VIEW (cadre_partie), column);
	column =
	gtk_tree_view_column_new_with_attributes ("Noirs", renderer, "text", 2,
							NULL);
	gtk_tree_view_append_column (GTK_TREE_VIEW (cadre_partie), column);
	Ascenseur = gtk_scrolled_window_new (NULL, NULL);
	gtk_container_set_border_width (GTK_CONTAINER (Ascenseur), 4);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (Ascenseur),
																				GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
	gtk_container_add (GTK_CONTAINER (Ascenseur), cadre_partie);
	gtk_tree_view_set_headers_clickable (GTK_TREE_VIEW (cadre_partie), FALSE);
	gtk_box_pack_start (GTK_BOX (boite), Ascenseur, TRUE, TRUE, 0);
/*
// Création de la fenêtre configuration réseau
table_reseau=gtk_table_new(5,1,FALSE);
gtk_table_attach(GTK_TABLE(table_principale), table_reseau,2,3,0,1,GTK_FILL,GTK_SHRINK,4,4);
image_reseau=gtk_image_new_from_stock(GTK_STOCK_NETWORK, GTK_ICON_SIZE_MENU);
bouton_connexion=gtk_button_new();
gtk_container_add(GTK_CONTAINER(bouton_connexion), image_reseau);
g_signal_connect(G_OBJECT(bouton_connexion), "clicked", (GCallback)connexion_gnuchess, NULL);
gtk_table_attach_defaults(GTK_TABLE(table_reseau), bouton_connexion, 0, 1, 0, 1);
G_label=gtk_label_new("ip :");
gtk_table_attach_defaults(GTK_TABLE(table_reseau), G_label, 1, 2, 0, 1);
ip=gtk_entry_new();
gtk_entry_set_max_length(GTK_ENTRY(ip), 255);
gtk_widget_set_size_request(ip, 200, 20);
gtk_table_attach_defaults(GTK_TABLE(table_reseau), ip, 2, 3, 0, 1);
G_label=gtk_label_new("port :");
gtk_table_attach_defaults(GTK_TABLE(table_reseau), G_label, 3, 4, 0, 1);
port=gtk_entry_new();
gtk_entry_set_max_length(GTK_ENTRY(port), 5);
gtk_widget_set_size_request(port, 50, 20);
gtk_table_attach_defaults(GTK_TABLE(table_reseau), port, 4, 5, 0, 1);
*/
	// Création d'une table pour la navigation dans la partie en cours
	table_navigation = gtk_table_new (1, 5, TRUE);
	gtk_box_pack_start (GTK_BOX (boite), table_navigation, FALSE, FALSE, 0);
	bouton_debut = gtk_button_new ();
	widget_list=gtk_data_list_add_by_name(widget_list, bouton_debut,
																																"bouton debut");
	gtk_button_set_relief (GTK_BUTTON (bouton_debut), GTK_RELIEF_NONE);
	gtk_container_add (GTK_CONTAINER (bouton_debut),
				 gtk_image_new_from_stock (GTK_STOCK_GOTO_FIRST,
					 GTK_ICON_SIZE_BUTTON));
	gtk_table_attach (GTK_TABLE (table_navigation), bouton_debut, 1, 2, 0, 1,
				GTK_SHRINK, GTK_SHRINK, 0, 0);
	bouton_recul = gtk_button_new ();
	widget_list=gtk_data_list_add_by_name(widget_list, bouton_recul,
																																"bouton recul");
	gtk_button_set_relief (GTK_BUTTON (bouton_recul), GTK_RELIEF_NONE);
	gtk_container_add (GTK_CONTAINER (bouton_recul),
				 gtk_image_new_from_stock (GTK_STOCK_GO_BACK,
					 GTK_ICON_SIZE_BUTTON));
	gtk_table_attach (GTK_TABLE (table_navigation), bouton_recul, 2, 3, 0, 1,
				GTK_SHRINK, GTK_SHRINK, 0, 0);
	bouton_avance = gtk_button_new ();
	widget_list=gtk_data_list_add_by_name(widget_list, bouton_avance,
																															"bouton avance");
	gtk_button_set_relief (GTK_BUTTON (bouton_avance), GTK_RELIEF_NONE);
	gtk_container_add (GTK_CONTAINER (bouton_avance),
				 gtk_image_new_from_stock (GTK_STOCK_GO_FORWARD,
					 GTK_ICON_SIZE_BUTTON));
	gtk_table_attach (GTK_TABLE (table_navigation), bouton_avance, 3, 4, 0, 1,
				GTK_SHRINK, GTK_SHRINK, 0, 0);
	bouton_dernier_coup = gtk_button_new ();
	widget_list=gtk_data_list_add_by_name(widget_list, bouton_dernier_coup,
																												"bouton dernier coup");
	gtk_button_set_relief (GTK_BUTTON (bouton_dernier_coup), GTK_RELIEF_NONE);
	gtk_container_add (GTK_CONTAINER (bouton_dernier_coup),
				 gtk_image_new_from_stock (GTK_STOCK_GOTO_LAST,
					 GTK_ICON_SIZE_BUTTON));
	gtk_table_attach (GTK_TABLE (table_navigation), bouton_dernier_coup, 4, 5,
				0, 1, GTK_SHRINK, GTK_SHRINK, 0, 0);
	// insensibles au début de la partie
	gtk_widget_set_sensitive (bouton_debut, FALSE);
	gtk_widget_set_sensitive (bouton_recul, FALSE);
	gtk_widget_set_sensitive (bouton_avance, FALSE);
	gtk_widget_set_sensitive (bouton_dernier_coup, FALSE);
	g_signal_connect (G_OBJECT (bouton_debut), "clicked",
				(GCallback) gnavigation_debut_partie, NULL);
	g_signal_connect (G_OBJECT (bouton_dernier_coup), "clicked",
				(GCallback) gnavigation_dernier_coup, NULL);
	g_signal_connect (G_OBJECT (bouton_recul), "clicked",
				(GCallback) gnavigation_recul, NULL);
	g_signal_connect (G_OBJECT (bouton_avance), "clicked",
				(GCallback) gnavigation_avance, NULL);
	// Création d'une table pour afficher les pièces prises.
	// Cette table est dessous le cadre_partie qui affiche les coups joués.
	table_pieces_prises = gtk_table_new (4, 8, TRUE);
	widget_list=gtk_data_list_add_by_name(widget_list, table_pieces_prises,
																												"table pieces prises");
	// Création d'un cadre contenant le tableau des pieces prises
	cadre_pieces_prises = gtk_frame_new ("Pièces prises");
	widget_list=gtk_data_list_add_by_name(widget_list, cadre_pieces_prises,
																												"cadre pieces prises");
	gtk_widget_set_size_request (table_pieces_prises, 192, 100);
	gtk_container_set_border_width (GTK_CONTAINER (cadre_pieces_prises), 4);
	gtk_frame_set_shadow_type (GTK_FRAME (cadre_pieces_prises),
					 GTK_SHADOW_ETCHED_OUT);
	gtk_container_add (GTK_CONTAINER (cadre_pieces_prises),
				 table_pieces_prises);
	gtk_box_pack_start (GTK_BOX (boite), cadre_pieces_prises, FALSE, FALSE,
		0);

	// Insertion d'un notebook qui contiendra la fenêtre d'état de la connection.
	notebook = gtk_notebook_new ();
	gtk_container_set_border_width (GTK_CONTAINER (notebook), 4);
	gtk_widget_set_size_request (notebook, 250, 200);
	gtk_table_attach(GTK_TABLE(table_paned_droit), notebook,1,2,0,1,GTK_SHRINK,
																										GTK_FILL|GTK_EXPAND, 0, 0);

	// Insertion d'une fenêtre d'état de la connexion au serveur de jeu dans le
	//notebook.
	ascenseur_etat = gtk_scrolled_window_new (NULL, NULL);
	gtk_container_set_border_width (GTK_CONTAINER (ascenseur_etat), 4);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (ascenseur_etat),
					GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	view = gtk_text_view_new ();
	widget_list=gtk_data_list_add_by_name(widget_list, view, "view");
	gtk_text_view_set_wrap_mode (GTK_TEXT_VIEW (view), GTK_WRAP_NONE);
	gtk_text_view_set_editable (GTK_TEXT_VIEW (view), FALSE);
	font_desc = pango_font_description_from_string ("Serif 8");
	gtk_widget_modify_font (view, font_desc);
	pango_font_description_free (font_desc);
	gtk_text_buffer_set_text (gtk_text_view_get_buffer (GTK_TEXT_VIEW (view)),
					"Linechec\nDéconnecté du serveur de jeu.\n",
					-1);
	gtk_container_add (GTK_CONTAINER (ascenseur_etat), view);
	gtk_notebook_append_page (GTK_NOTEBOOK (notebook), ascenseur_etat,
					gtk_label_new ("Etat"));

	// Création d'une barre d'état
	// Insertion d'une ligne séparatrice horizontale entre l'interface
	// et la barre d'état.
	separateur_horizontal = gtk_hseparator_new ();
	gtk_box_pack_start (GTK_BOX (boite_principale), separateur_horizontal,
		FALSE, FALSE, 0);

	barre_etat = gtk_hbox_new (FALSE, 0);
	gtk_box_pack_start (GTK_BOX (boite_principale), barre_etat, FALSE, FALSE,
		0);

	// Etat de la connexion au serveur
	connexion_tips = gtk_tooltips_new ();
	connexion =
	gtk_image_new_from_stock (GTK_STOCK_DISCONNECT, GTK_ICON_SIZE_MENU);
	widget_list=gtk_data_list_add_by_name(widget_list, connexion, "connexion");
	event_tips = gtk_event_box_new ();
	gtk_container_add (GTK_CONTAINER (event_tips), connexion);
	gtk_box_pack_end (GTK_BOX (barre_etat), event_tips, FALSE, FALSE, 0);
	gtk_tooltips_set_tip (GTK_TOOLTIPS (connexion_tips), event_tips,
			"Moteur de jeu déconnecté",
			"Moteur de jeu déconnecté");
	G_label = gtk_label_new ("Connexion :");
	gtk_box_pack_end (GTK_BOX (barre_etat), G_label, FALSE, FALSE, 0);
	// Insertion d'une ligne séparatrice verticale
	separateur_horizontal = gtk_vseparator_new ();
	gtk_box_pack_end (GTK_BOX (barre_etat), separateur_horizontal, FALSE,
				FALSE, 0);
	// signaux pour la fermeture de l'application
	g_signal_connect (G_OBJECT (fenetre_principale), "destroy",
				(GCallback) g_quitter, NULL);
	
	return fenetre_principale;
}
